---------------------------------------------
--             Statistix v1.1.1                --
---------------------------------------------
if gmx==nil then _OpenScript("lib/gmx/init.lua") end

--SX_MODE variable
--0 for local file. This means you are using the webserver included.
--1 for MySQL
SX_MODE = 1
SX_LIVE = 0
SX_KILLS = 0
SX_PROPS = 0
CHATLOG = ""
SQLCHATLOG = {};

sx_interval = 30 -- This is the normal mode interval (writes a file every 30 seconds)
sx_MySQL_interval = 120 --This is the MySQL mode interval

--MySQL settings these are required for SX_MODE 1
HOSTIP = "spoco.ath.cx"
DB = "gmod"
USER = "gmod"
PASS = "password"

--Teams table
teams = {
	"Unassigned",
	"Spectator",
	"Blue",
	"Yellow",
	"Green",
	"Red"
}

if SX_MODE == 1 then
	require"luasql.mysql"
end

function countPlayers()
 local players = 0
 for i=1, _MaxPlayers() do
  if _PlayerInfo( i, "connected" ) then
   players = players + 1
  end
 end
 return players
end

function printPlayer()
 local cell = ""
 for i=1, _MaxPlayers() do
  if _PlayerInfo( i, "connected" ) then
   local alive = ""
   local teamnum = _PlayerInfo(i,"team")
   local team = teams[teamnum + 1];
   
    if _PlayerInfo(i,"alive") then 
		alive = "Yes"
	else 
		alive = "No"
	end
	
   cell = cell .. '<tr><td> ' .. _PlayerInfo(i,"name") .. ' </td><td> ' .. _PlayerInfo(i,"SX_KILLS") .. ' </td><td> ' .. _PlayerInfo(i,"deaths") .. ' </td><td> ' .. _PlayerInfo(i,"ping") .. ' </td><td> ' .. _PlayerInfo(i,"networkid") .. ' </td><td> ' .. _PlayerInfo(i,"health") .. ' </td><td> ' .. alive .. ' </td><td> ' .. team .. ' </td></tr> '
  end
 end
 return cell
end

function ShowStats(userid)
 CURRENTMAP = _GetCurrentMap()
 NEXTMAP = _GetNextMap()
 TIME = ToMinutesSeconds(_CurTime())
 _PrintMessage(userid,HUD_PRINTCONSOLE,"\n")
 _PrintMessage(userid,HUD_PRINTCONSOLE,"Server Name: " .. _GetConVar_String("hostname"))
 _PrintMessage(userid,HUD_PRINTCONSOLE,"Server OS: " .. OS())
 _PrintMessage(userid,HUD_PRINTCONSOLE,"Dedicated?: " .. Dedicated())
 _PrintMessage(userid,HUD_PRINTCONSOLE,"Cheats?: " .. Cheats())
 _PrintMessage(userid,HUD_PRINTCONSOLE,"SX_KILLS: " .. SX_KILLS)
 _PrintMessage(userid,HUD_PRINTCONSOLE,"Server Uptime: " .. TIME)
 _PrintMessage(userid,HUD_PRINTCONSOLE,"Number of SX_PROPS spawned: " .. SX_PROPS)
 _PrintMessage(userid,HUD_PRINTCONSOLE,"Current Map: " .. CURRENTMAP)
 _PrintMessage(userid,HUD_PRINTCONSOLE,"Next Map: " .. NEXTMAP)
 _PrintMessage(userid,HUD_PRINTCONSOLE,"Players: " .. countPlayers() .. "/" .. _MaxPlayers())
end

function mapImage()
local url
if Dedicated() == "No" then
if SX_LIVE == 1 then
 _ServerCommand("jpeg_quality 90\n")
 _ServerCommand("jpeg realtimecamera\n")
 url = "<img src=screenshots/realtimecamera.jpg width=400 height=300>"
end
end
if Dedicated() == "Yes" then
 url = "<img src=mapimages/".._GetCurrentMap()..".jpg>"
end
return url
end

function OS()
 if _IsLinux() == false then return "Windows"
 elseif _IsLinux() == true then return "Linux" 
 else return "Unknown" end
end

function Dedicated()
 if _IsDedicatedServer() == false then return "No"
 elseif _IsDedicatedServer() == true then return "Yes" 
 else return "Unknown" end
end

function Cheats()
 if _GetConVar_Bool("sv_cheats") == false then return "No"
 elseif _GetConVar_Bool("sv_cheats") == true then return "Yes" 
 else return "Unknown" end
end

function sx_playersay(userid, strText, bTeam)
	if SX_MODE == 0 then
		CHATLOG =  "<tr><td class='message'>" .. strText .. "</td></tr>" .. CHATLOG
	elseif SX_MODE == 1 then
		local msg = {}
		msg.msg = strText;
		msg.time = ToMinutesSeconds(_CurTime());
		table.insert(SQLCHATLOG, msg);
	end
	
	return strText
end
HookEvent("eventPlayerSay", sx_playersay);

function sx_playerkilled(userid,attacker,weapon)
  SX_KILLS = SX_KILLS + 1
end
HookEvent("eventPlayerKilled", sx_playerkilled);

function sx_spawnprop(userid, propname)
  SX_PROPS = SX_PROPS + 1
  return
end
HookEvent("eventPlayerSpawnProp", sx_spawnprop);

function WriteStats()
  if SX_MODE == 0 then
	  CURRENTMAP = _GetCurrentMap()
	  NEXTMAP = _GetNextMap()
	  TIME = ToMinutesSeconds(_CurTime())
	  local buf = _file.Read("stats//template.html");
	  buf = string.gsub(buf, "@SERVERNAME@", _GetConVar_String("hostname"));
	  buf = string.gsub(buf, "@OS@", OS());
	  buf = string.gsub(buf, "@DEDICATED@", Dedicated());
	  buf = string.gsub(buf, "@CHEATS@", Cheats());
	  buf = string.gsub(buf, "@SX_KILLS@", SX_KILLS);
	  buf = string.gsub(buf, "@TIME@", TIME);
	  buf = string.gsub(buf, "@SX_PROPS@", SX_PROPS);
	  buf = string.gsub(buf, "@CURRENTMAP@", CURRENTMAP);
	  buf = string.gsub(buf, "@NEXTMAP@", NEXTMAP);
	  buf = string.gsub(buf, "@PLAYERS@", countPlayers() .. "/" .. _MaxPlayers());
	  buf = string.gsub(buf, "@MAPIMAGE@", mapImage());
	  buf = string.gsub(buf, "@PLAYERSBLOCK@", printPlayer());
	  buf = string.gsub(buf, "@CHATLOG@", CHATLOG);
	  _file.Write("stats//index.html", buf);
	  
	  AddTimer(sx_interval, 1, WriteStats)
  elseif SX_MODE == 1 then
		env = assert (luasql.mysql()) --Open LuaSQL MySQL environment as new object 'env'
		con = assert (env:connect(DB, USER, PASS, HOSTIP)) --Open connection to a MySQL database.
		
		--sx_common update
		sx_sqlcommon("hostname", _GetConVar_String("hostname"));
		sx_sqlcommon("uptime", ToMinutesSeconds(_CurTime()));
		sx_sqlcommon("OS", OS());
		sx_sqlcommon("dedicated", Dedicated());
		sx_sqlcommon("curplayers", countPlayers());
		sx_sqlcommon("maxplayers", _MaxPlayers());
		sx_sqlcommon("totalkills", SX_KILLS);
		sx_sqlcommon("props_spawned", SX_PROPS);
		sx_sqlcommon("sv_cheats", Cheats());
		sx_sqlcommon("curmap", _GetCurrentMap());
		sx_sqlcommon("nextmap", _GetNextMap());
		
		--sx_chatlog update
		sx_sqlchatlog();
		
		--sx_players update
		sx_sqlplayers();
		
		con:close()
		env:close()
		
		_PrintMessageAll(2, "MySQL tables updated!\n");
		AddTimer(sx_MySQL_interval, 1, WriteStats)
  end  
  
end

function sx_sqlcommon (ID, Value)
	local query = "update sx_common set Value='" .. Value .. "' where ID='" .. ID .. "'";
	cur = assert (con:execute(query))
end

function sx_sqlchatlog()
	for i in SQLCHATLOG do
		local query = "INSERT INTO sx_chatlog (time,message) VALUES ('" .. SQLCHATLOG[i].time .. "','" .. SQLCHATLOG[i].msg .. "')";
		cur = assert (con:execute(query))
	end
	SQLCHATLOG = {};
end

function sx_sqlplayers()
	for i = 1, countPlayers() do
		if _PlayerInfo(i, "connected") then
			local name = _PlayerInfo(i, "name")
			local kills = _PlayerInfo(i, "kills")
			local deaths = _PlayerInfo(i, "deaths")
			local ping = _PlayerInfo(i, "ping")
			local health = _PlayerInfo(i, "health")
			local steamid = _PlayerInfo(i, "networkid")
			
			local teamnum = _PlayerInfo(i,"team")
			local team = teams[teamnum + 1];
			
			local alive = ""
			
		    if _PlayerInfo(i,"alive") then 
				alive = "Yes"
		    else 
				alive = "No"
			end
		   
			local query = "UPDATE sx_players SET name='" .. name .. "', kills='" .. kills .. "', deaths='" .. deaths .. "', ping='" .. ping .. "', steamid='" .. steamid .. "', health='" .. health .. "', alive='" .. alive .. "', team='" .. team .. "' WHERE ID=" .. i
			cur = assert (con:execute(query))
		end
			
	end

end

function sx_startmap()
	WriteStats();
end
HookEvent("gamerulesStartMap", sx_startmap);

if Dedicated() == "No" and SX_MODE == 0 then
	AddTimer(30, 0, mapImage)
end

CONCOMMAND("statsme",ShowStats)

_Msg("Statistix v1.1.0 loaded!\n")

